/* SqlDataType.c generated by valac 0.13.4, the Vala compiler
 * generated from SqlDataType.vala, do not modify */

/*
 *   This file is part of Clinica.
 *
 *   Clinica is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Clinica is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Clinica.  If not, see <http://www.gnu.org/licenses/>.
 *
 *   Authors: Leonardo Robol <leo@robol.it>
 *            Gianmarco Brocchi <brocchi@poisson.phc.unipi.it>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define CLINICA_TYPE_SQL_COLUMN (clinica_sql_column_get_type ())
#define CLINICA_SQL_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLINICA_TYPE_SQL_COLUMN, ClinicaSqlColumn))
#define CLINICA_SQL_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLINICA_TYPE_SQL_COLUMN, ClinicaSqlColumnClass))
#define CLINICA_IS_SQL_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLINICA_TYPE_SQL_COLUMN))
#define CLINICA_IS_SQL_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLINICA_TYPE_SQL_COLUMN))
#define CLINICA_SQL_COLUMN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLINICA_TYPE_SQL_COLUMN, ClinicaSqlColumnClass))

typedef struct _ClinicaSqlColumn ClinicaSqlColumn;
typedef struct _ClinicaSqlColumnClass ClinicaSqlColumnClass;
typedef struct _ClinicaSqlColumnPrivate ClinicaSqlColumnPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ClinicaParamSpecSqlColumn ClinicaParamSpecSqlColumn;

#define CLINICA_TYPE_SQL_DATA_ITERATOR (clinica_sql_data_iterator_get_type ())
#define CLINICA_SQL_DATA_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLINICA_TYPE_SQL_DATA_ITERATOR, ClinicaSqlDataIterator))
#define CLINICA_SQL_DATA_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLINICA_TYPE_SQL_DATA_ITERATOR, ClinicaSqlDataIteratorClass))
#define CLINICA_IS_SQL_DATA_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLINICA_TYPE_SQL_DATA_ITERATOR))
#define CLINICA_IS_SQL_DATA_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLINICA_TYPE_SQL_DATA_ITERATOR))
#define CLINICA_SQL_DATA_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLINICA_TYPE_SQL_DATA_ITERATOR, ClinicaSqlDataIteratorClass))

typedef struct _ClinicaSqlDataIterator ClinicaSqlDataIterator;
typedef struct _ClinicaSqlDataIteratorClass ClinicaSqlDataIteratorClass;
typedef struct _ClinicaSqlDataIteratorPrivate ClinicaSqlDataIteratorPrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

#define CLINICA_TYPE_SQL_DATA_TYPE (clinica_sql_data_type_get_type ())
#define CLINICA_SQL_DATA_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLINICA_TYPE_SQL_DATA_TYPE, ClinicaSqlDataType))
#define CLINICA_SQL_DATA_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLINICA_TYPE_SQL_DATA_TYPE, ClinicaSqlDataTypeClass))
#define CLINICA_IS_SQL_DATA_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLINICA_TYPE_SQL_DATA_TYPE))
#define CLINICA_IS_SQL_DATA_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLINICA_TYPE_SQL_DATA_TYPE))
#define CLINICA_SQL_DATA_TYPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLINICA_TYPE_SQL_DATA_TYPE, ClinicaSqlDataTypeClass))

typedef struct _ClinicaSqlDataType ClinicaSqlDataType;
typedef struct _ClinicaSqlDataTypeClass ClinicaSqlDataTypeClass;
typedef struct _ClinicaSqlDataTypePrivate ClinicaSqlDataTypePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _clinica_sql_column_unref0(var) ((var == NULL) ? NULL : (var = (clinica_sql_column_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _ClinicaSqlColumn {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ClinicaSqlColumnPrivate * priv;
	gchar* type;
	gchar* v;
};

struct _ClinicaSqlColumnClass {
	GTypeClass parent_class;
	void (*finalize) (ClinicaSqlColumn *self);
};

struct _ClinicaParamSpecSqlColumn {
	GParamSpec parent_instance;
};

struct _ClinicaSqlDataIterator {
	GObject parent_instance;
	ClinicaSqlDataIteratorPrivate * priv;
	sqlite3* db;
	sqlite3_stmt* stmt;
};

struct _ClinicaSqlDataIteratorClass {
	GObjectClass parent_class;
};

struct _ClinicaSqlDataType {
	GObject parent_instance;
	ClinicaSqlDataTypePrivate * priv;
	gchar* table_name;
	sqlite3* db;
	GeeHashMap* columns;
};

struct _ClinicaSqlDataTypeClass {
	GObjectClass parent_class;
};

struct _ClinicaSqlDataTypePrivate {
	GStaticRecMutex __lock_db;
};


static gpointer clinica_sql_column_parent_class = NULL;
static gpointer clinica_sql_data_iterator_parent_class = NULL;
static gpointer clinica_sql_data_type_parent_class = NULL;

gpointer clinica_sql_column_ref (gpointer instance);
void clinica_sql_column_unref (gpointer instance);
GParamSpec* clinica_param_spec_sql_column (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void clinica_value_set_sql_column (GValue* value, gpointer v_object);
void clinica_value_take_sql_column (GValue* value, gpointer v_object);
gpointer clinica_value_get_sql_column (const GValue* value);
GType clinica_sql_column_get_type (void) G_GNUC_CONST;
enum  {
	CLINICA_SQL_COLUMN_DUMMY_PROPERTY
};
ClinicaSqlColumn* clinica_sql_column_new (const gchar* type);
ClinicaSqlColumn* clinica_sql_column_construct (GType object_type, const gchar* type);
static void clinica_sql_column_finalize (ClinicaSqlColumn* obj);
GType clinica_sql_data_iterator_get_type (void) G_GNUC_CONST;
enum  {
	CLINICA_SQL_DATA_ITERATOR_DUMMY_PROPERTY
};
ClinicaSqlDataIterator* clinica_sql_data_iterator_new (sqlite3* db, const gchar* table_name);
ClinicaSqlDataIterator* clinica_sql_data_iterator_construct (GType object_type, sqlite3* db, const gchar* table_name);
ClinicaSqlDataIterator* clinica_sql_data_iterator_iterator (ClinicaSqlDataIterator* self);
gboolean clinica_sql_data_iterator_next (ClinicaSqlDataIterator* self);
gint clinica_sql_data_iterator_get (ClinicaSqlDataIterator* self);
static void clinica_sql_data_iterator_finalize (GObject* obj);
GType clinica_sql_data_type_get_type (void) G_GNUC_CONST;
#define CLINICA_SQL_DATA_TYPE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CLINICA_TYPE_SQL_DATA_TYPE, ClinicaSqlDataTypePrivate))
enum  {
	CLINICA_SQL_DATA_TYPE_DUMMY_PROPERTY
};
ClinicaSqlDataType* clinica_sql_data_type_new (sqlite3* db);
ClinicaSqlDataType* clinica_sql_data_type_construct (GType object_type, sqlite3* db);
void clinica_sql_data_type_set_integer (ClinicaSqlDataType* self, const gchar* field, gint64 val);
ClinicaSqlDataType* clinica_sql_data_type_new_with_id (sqlite3* db, gint ID);
ClinicaSqlDataType* clinica_sql_data_type_construct_with_id (GType object_type, sqlite3* db, gint ID);
void clinica_sql_data_type_load (ClinicaSqlDataType* self, gint ID);
void clinica_sql_data_type_add_text_field (ClinicaSqlDataType* self, const gchar* name);
void clinica_sql_data_type_add_integer_field (ClinicaSqlDataType* self, const gchar* name);
void clinica_sql_data_type_add_date_field (ClinicaSqlDataType* self, const gchar* name);
gchar* clinica_sql_data_type_quote (ClinicaSqlDataType* self, const gchar* str);
void clinica_sql_data_type_init_resources (ClinicaSqlDataType* self);
void clinica_sql_data_type_init_database (ClinicaSqlDataType* self);
gchar* clinica_sql_data_type_get_db_table_name (ClinicaSqlDataType* self);
void clinica_sql_data_type_set_text (ClinicaSqlDataType* self, const gchar* field, const gchar* val);
const gchar* clinica_sql_data_type_get_text (ClinicaSqlDataType* self, const gchar* field);
gint clinica_sql_data_type_get_integer (ClinicaSqlDataType* self, const gchar* field);
GDateTime* clinica_sql_data_type_get_date (ClinicaSqlDataType* self, const gchar* field);
void clinica_sql_data_type_set_date (ClinicaSqlDataType* self, const gchar* field, GDateTime* date);
gint clinica_sql_data_type_get_id (ClinicaSqlDataType* self);
gchar* clinica_sql_data_type_get (ClinicaSqlDataType* self, const gchar* field);
void clinica_sql_data_type_set (ClinicaSqlDataType* self, const gchar* field, const gchar* value);
void clinica_sql_data_type_save (ClinicaSqlDataType* self);
void clinica_sql_data_type_remove (ClinicaSqlDataType* self);
GList* clinica_sql_data_type_associated_ids (ClinicaSqlDataType* self, const gchar* ex_table, const gchar* foreign_key);
static void clinica_sql_data_type_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


ClinicaSqlColumn* clinica_sql_column_construct (GType object_type, const gchar* type) {
	ClinicaSqlColumn* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (type != NULL, NULL);
	self = (ClinicaSqlColumn*) g_type_create_instance (object_type);
	_tmp0_ = type;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->type);
	self->type = _tmp1_;
	return self;
}


ClinicaSqlColumn* clinica_sql_column_new (const gchar* type) {
	return clinica_sql_column_construct (CLINICA_TYPE_SQL_COLUMN, type);
}


static void clinica_value_sql_column_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void clinica_value_sql_column_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		clinica_sql_column_unref (value->data[0].v_pointer);
	}
}


static void clinica_value_sql_column_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = clinica_sql_column_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer clinica_value_sql_column_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* clinica_value_sql_column_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ClinicaSqlColumn* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = clinica_sql_column_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* clinica_value_sql_column_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ClinicaSqlColumn** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = clinica_sql_column_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* clinica_param_spec_sql_column (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ClinicaParamSpecSqlColumn* spec;
	g_return_val_if_fail (g_type_is_a (object_type, CLINICA_TYPE_SQL_COLUMN), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer clinica_value_get_sql_column (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CLINICA_TYPE_SQL_COLUMN), NULL);
	return value->data[0].v_pointer;
}


void clinica_value_set_sql_column (GValue* value, gpointer v_object) {
	ClinicaSqlColumn* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CLINICA_TYPE_SQL_COLUMN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CLINICA_TYPE_SQL_COLUMN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		clinica_sql_column_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		clinica_sql_column_unref (old);
	}
}


void clinica_value_take_sql_column (GValue* value, gpointer v_object) {
	ClinicaSqlColumn* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CLINICA_TYPE_SQL_COLUMN));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CLINICA_TYPE_SQL_COLUMN));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		clinica_sql_column_unref (old);
	}
}


static void clinica_sql_column_class_init (ClinicaSqlColumnClass * klass) {
	clinica_sql_column_parent_class = g_type_class_peek_parent (klass);
	CLINICA_SQL_COLUMN_CLASS (klass)->finalize = clinica_sql_column_finalize;
}


static void clinica_sql_column_instance_init (ClinicaSqlColumn * self) {
	self->ref_count = 1;
}


static void clinica_sql_column_finalize (ClinicaSqlColumn* obj) {
	ClinicaSqlColumn * self;
	self = CLINICA_SQL_COLUMN (obj);
	_g_free0 (self->type);
	_g_free0 (self->v);
}


/**
     * @brief Struct representing a column in the database.
     */
GType clinica_sql_column_get_type (void) {
	static volatile gsize clinica_sql_column_type_id__volatile = 0;
	if (g_once_init_enter (&clinica_sql_column_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { clinica_value_sql_column_init, clinica_value_sql_column_free_value, clinica_value_sql_column_copy_value, clinica_value_sql_column_peek_pointer, "p", clinica_value_sql_column_collect_value, "p", clinica_value_sql_column_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ClinicaSqlColumnClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clinica_sql_column_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClinicaSqlColumn), 0, (GInstanceInitFunc) clinica_sql_column_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType clinica_sql_column_type_id;
		clinica_sql_column_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ClinicaSqlColumn", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&clinica_sql_column_type_id__volatile, clinica_sql_column_type_id);
	}
	return clinica_sql_column_type_id__volatile;
}


gpointer clinica_sql_column_ref (gpointer instance) {
	ClinicaSqlColumn* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void clinica_sql_column_unref (gpointer instance) {
	ClinicaSqlColumn* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CLINICA_SQL_COLUMN_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


ClinicaSqlDataIterator* clinica_sql_data_iterator_construct (GType object_type, sqlite3* db, const gchar* table_name) {
	ClinicaSqlDataIterator * self = NULL;
	sqlite3* _tmp0_;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	g_return_val_if_fail (db != NULL, NULL);
	g_return_val_if_fail (table_name != NULL, NULL);
	self = (ClinicaSqlDataIterator*) g_object_new (object_type, NULL);
	_tmp0_ = db;
	self->db = _tmp0_;
	_tmp1_ = db;
	_tmp2_ = table_name;
	_tmp3_ = string_to_string (_tmp2_);
	_tmp4_ = g_strconcat ("SELECT ID FROM ", _tmp3_, ";", NULL);
	_tmp5_ = _tmp4_;
	sqlite3_prepare (_tmp1_, _tmp5_, -1, &_tmp6_, NULL);
	_sqlite3_finalize0 (self->stmt);
	self->stmt = _tmp6_;
	_g_free0 (_tmp5_);
	return self;
}


ClinicaSqlDataIterator* clinica_sql_data_iterator_new (sqlite3* db, const gchar* table_name) {
	return clinica_sql_data_iterator_construct (CLINICA_TYPE_SQL_DATA_ITERATOR, db, table_name);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


ClinicaSqlDataIterator* clinica_sql_data_iterator_iterator (ClinicaSqlDataIterator* self) {
	ClinicaSqlDataIterator* result = NULL;
	ClinicaSqlDataIterator* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = _g_object_ref0 (self);
	result = _tmp0_;
	return result;
}


gboolean clinica_sql_data_iterator_next (ClinicaSqlDataIterator* self) {
	gboolean result = FALSE;
	sqlite3_stmt* _tmp0_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->stmt;
	_tmp1_ = sqlite3_step (_tmp0_);
	result = _tmp1_ == SQLITE_ROW;
	return result;
}


gint clinica_sql_data_iterator_get (ClinicaSqlDataIterator* self) {
	gint result = 0;
	sqlite3_stmt* _tmp0_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->stmt;
	_tmp1_ = sqlite3_column_int (_tmp0_, 0);
	result = _tmp1_;
	return result;
}


static void clinica_sql_data_iterator_class_init (ClinicaSqlDataIteratorClass * klass) {
	clinica_sql_data_iterator_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = clinica_sql_data_iterator_finalize;
}


static void clinica_sql_data_iterator_instance_init (ClinicaSqlDataIterator * self) {
}


static void clinica_sql_data_iterator_finalize (GObject* obj) {
	ClinicaSqlDataIterator * self;
	self = CLINICA_SQL_DATA_ITERATOR (obj);
	_sqlite3_finalize0 (self->stmt);
	G_OBJECT_CLASS (clinica_sql_data_iterator_parent_class)->finalize (obj);
}


GType clinica_sql_data_iterator_get_type (void) {
	static volatile gsize clinica_sql_data_iterator_type_id__volatile = 0;
	if (g_once_init_enter (&clinica_sql_data_iterator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClinicaSqlDataIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clinica_sql_data_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClinicaSqlDataIterator), 0, (GInstanceInitFunc) clinica_sql_data_iterator_instance_init, NULL };
		GType clinica_sql_data_iterator_type_id;
		clinica_sql_data_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "ClinicaSqlDataIterator", &g_define_type_info, 0);
		g_once_init_leave (&clinica_sql_data_iterator_type_id__volatile, clinica_sql_data_iterator_type_id);
	}
	return clinica_sql_data_iterator_type_id__volatile;
}


ClinicaSqlDataType* clinica_sql_data_type_construct (GType object_type, sqlite3* db) {
	ClinicaSqlDataType * self = NULL;
	sqlite3* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	ClinicaSqlColumn* _tmp3_;
	ClinicaSqlColumn* _tmp4_;
	g_return_val_if_fail (db != NULL, NULL);
	self = (ClinicaSqlDataType*) g_object_new (object_type, NULL);
	_tmp0_ = db;
	self->db = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, CLINICA_TYPE_SQL_COLUMN, (GBoxedCopyFunc) clinica_sql_column_ref, clinica_sql_column_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->columns);
	self->columns = _tmp1_;
	_tmp2_ = self->columns;
	_tmp3_ = clinica_sql_column_new ("INTEGER PRIMARY KEY");
	_tmp4_ = _tmp3_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, "ID", _tmp4_);
	_clinica_sql_column_unref0 (_tmp4_);
	clinica_sql_data_type_set_integer (self, "ID", (gint64) 0);
	return self;
}


ClinicaSqlDataType* clinica_sql_data_type_new (sqlite3* db) {
	return clinica_sql_data_type_construct (CLINICA_TYPE_SQL_DATA_TYPE, db);
}


ClinicaSqlDataType* clinica_sql_data_type_construct_with_id (GType object_type, sqlite3* db, gint ID) {
	ClinicaSqlDataType * self = NULL;
	sqlite3* _tmp0_;
	gint _tmp1_;
	g_return_val_if_fail (db != NULL, NULL);
	_tmp0_ = db;
	self = (ClinicaSqlDataType*) clinica_sql_data_type_construct (object_type, _tmp0_);
	_tmp1_ = ID;
	clinica_sql_data_type_load (self, _tmp1_);
	return self;
}


ClinicaSqlDataType* clinica_sql_data_type_new_with_id (sqlite3* db, gint ID) {
	return clinica_sql_data_type_construct_with_id (CLINICA_TYPE_SQL_DATA_TYPE, db, ID);
}


void clinica_sql_data_type_add_text_field (ClinicaSqlDataType* self, const gchar* name) {
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	ClinicaSqlColumn* _tmp2_;
	ClinicaSqlColumn* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->columns;
	_tmp1_ = name;
	_tmp2_ = clinica_sql_column_new ("TEXT");
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp1_, _tmp3_);
	_clinica_sql_column_unref0 (_tmp3_);
}


void clinica_sql_data_type_add_integer_field (ClinicaSqlDataType* self, const gchar* name) {
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	ClinicaSqlColumn* _tmp2_;
	ClinicaSqlColumn* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->columns;
	_tmp1_ = name;
	_tmp2_ = clinica_sql_column_new ("INTEGER");
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp1_, _tmp3_);
	_clinica_sql_column_unref0 (_tmp3_);
}


void clinica_sql_data_type_add_date_field (ClinicaSqlDataType* self, const gchar* name) {
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	ClinicaSqlColumn* _tmp2_;
	ClinicaSqlColumn* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = self->columns;
	_tmp1_ = name;
	_tmp2_ = clinica_sql_column_new ("TEXT");
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp1_, _tmp3_);
	_clinica_sql_column_unref0 (_tmp3_);
}


/**
         * @brief Escape a string and surround it with
         * double quotes ready to be inserted in the 
         * database.
         */
gchar* clinica_sql_data_type_quote (ClinicaSqlDataType* self, const gchar* str) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = str;
	_tmp1_ = g_strescape (_tmp0_, "");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("\"", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, "\"", NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	result = _tmp6_;
	return result;
}


/**
         * @brief Initialize resource, i.e. open the database
         * and check for missing tables.
         */
void clinica_sql_data_type_init_resources (ClinicaSqlDataType* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		sqlite3* _tmp0_;
		_tmp0_ = self->db;
		g_static_rec_mutex_lock (&self->priv->__lock_db);
		{
			sqlite3_stmt* stmt = NULL;
			sqlite3* _tmp1_;
			const gchar* _tmp2_;
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			sqlite3_stmt* _tmp6_ = NULL;
			sqlite3_stmt* _tmp7_;
			gint _tmp8_ = 0;
			_tmp1_ = self->db;
			_tmp2_ = self->table_name;
			_tmp3_ = string_to_string (_tmp2_);
			_tmp4_ = g_strconcat ("SELECT * from sqlite_master WHERE name='", _tmp3_, "';", NULL);
			_tmp5_ = _tmp4_;
			sqlite3_prepare (_tmp1_, _tmp5_, -1, &_tmp6_, NULL);
			_sqlite3_finalize0 (stmt);
			stmt = _tmp6_;
			_g_free0 (_tmp5_);
			_tmp7_ = stmt;
			_tmp8_ = sqlite3_step (_tmp7_);
			if (_tmp8_ == SQLITE_DONE) {
				clinica_sql_data_type_init_database (self);
			}
			_sqlite3_finalize0 (stmt);
		}
		__finally6:
		{
			sqlite3* _tmp9_;
			_tmp9_ = self->db;
			g_static_rec_mutex_unlock (&self->priv->__lock_db);
		}
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
         * @brief Create table structure in the database.
         */
static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	glong string_length;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	glong _tmp14_;
	gboolean _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_;
		glong _tmp4_;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_;
		glong _tmp7_;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp12_ = _tmp8_;
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp14_ = end;
	if (_tmp14_ >= ((glong) 0)) {
		glong _tmp15_;
		glong _tmp16_;
		_tmp15_ = end;
		_tmp16_ = string_length;
		_tmp13_ = _tmp15_ <= _tmp16_;
	} else {
		_tmp13_ = FALSE;
	}
	_tmp17_ = _tmp13_;
	g_return_val_if_fail (_tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	g_return_val_if_fail (_tmp18_ <= _tmp19_, NULL);
	_tmp20_ = start;
	_tmp21_ = end;
	_tmp22_ = start;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) (_tmp21_ - _tmp22_));
	result = _tmp23_;
	return result;
}


void clinica_sql_data_type_init_database (ClinicaSqlDataType* self) {
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* sql;
	const gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	sqlite3* _tmp30_;
	const gchar* _tmp31_;
	sqlite3_stmt* _tmp32_ = NULL;
	sqlite3_stmt* _tmp33_;
	gint _tmp34_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table_name;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = g_strconcat ("CREATE TABLE ", _tmp1_, " (", NULL);
	sql = _tmp2_;
	{
		GeeHashMap* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _tmp8_;
		GeeIterator* _e_it;
		_tmp3_ = self->columns;
		_tmp4_ = gee_map_get_entries ((GeeMap*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_e_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeIterator* _tmp11_;
			gpointer _tmp12_ = NULL;
			GeeMapEntry* e;
			const gchar* _tmp13_;
			GeeMapEntry* _tmp14_;
			gconstpointer _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_ = NULL;
			GeeMapEntry* _tmp18_;
			gconstpointer _tmp19_;
			ClinicaSqlColumn* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			gchar* _tmp24_;
			gchar* _tmp25_;
			_tmp9_ = _e_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _e_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			e = (GeeMapEntry*) _tmp12_;
			_tmp13_ = sql;
			_tmp14_ = e;
			_tmp15_ = gee_map_entry_get_key (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = string_to_string ((const gchar*) _tmp16_);
			_tmp18_ = e;
			_tmp19_ = gee_map_entry_get_value (_tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = ((ClinicaSqlColumn*) _tmp20_)->type;
			_tmp22_ = string_to_string (_tmp21_);
			_tmp23_ = g_strconcat (_tmp17_, " ", _tmp22_, ", ", NULL);
			_tmp24_ = _tmp23_;
			_tmp25_ = g_strconcat (_tmp13_, _tmp24_, NULL);
			_g_free0 (sql);
			sql = _tmp25_;
			_g_free0 (_tmp24_);
			_g_object_unref0 (e);
		}
		_g_object_unref0 (_e_it);
	}
	_tmp26_ = sql;
	_tmp27_ = string_slice (_tmp26_, (glong) 0, (glong) (-2));
	_g_free0 (sql);
	sql = _tmp27_;
	_tmp28_ = sql;
	_tmp29_ = g_strconcat (_tmp28_, ");", NULL);
	_g_free0 (sql);
	sql = _tmp29_;
	_tmp30_ = self->db;
	_tmp31_ = sql;
	sqlite3_prepare (_tmp30_, _tmp31_, -1, &_tmp32_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp32_;
	_tmp33_ = stmt;
	_tmp34_ = sqlite3_step (_tmp33_);
	if (_tmp34_ != SQLITE_DONE) {
		const gchar* _tmp35_;
		const gchar* _tmp36_ = NULL;
		gchar* _tmp37_ = NULL;
		gchar* _tmp38_;
		_tmp35_ = self->table_name;
		_tmp36_ = string_to_string (_tmp35_);
		_tmp37_ = g_strconcat ("Error creating ", _tmp36_, " table in the database.", NULL);
		_tmp38_ = _tmp37_;
		g_signal_emit_by_name (self, "error", _tmp38_);
		_g_free0 (_tmp38_);
	}
	_g_free0 (sql);
	_sqlite3_finalize0 (stmt);
}


gchar* clinica_sql_data_type_get_db_table_name (ClinicaSqlDataType* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->table_name;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


void clinica_sql_data_type_set_text (ClinicaSqlDataType* self, const gchar* field, const gchar* val) {
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_ = NULL;
	ClinicaSqlColumn* col;
	ClinicaSqlColumn* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GeeHashMap* _tmp17_;
	const gchar* _tmp18_;
	ClinicaSqlColumn* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (val != NULL);
	_tmp0_ = self->columns;
	_tmp1_ = field;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	if (!_tmp2_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = field;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = self->table_name;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat ("Error saving to field ", _tmp4_, " from table ", _tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, "Selected field is not present in database", NULL);
		_tmp10_ = _tmp9_;
		g_signal_emit_by_name (self, "error", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		return;
	}
	_tmp11_ = self->columns;
	_tmp12_ = field;
	_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
	col = (ClinicaSqlColumn*) _tmp13_;
	_tmp14_ = col;
	_tmp15_ = val;
	_tmp16_ = g_strdup (_tmp15_);
	_g_free0 (_tmp14_->v);
	_tmp14_->v = _tmp16_;
	_tmp17_ = self->columns;
	_tmp18_ = field;
	_tmp19_ = col;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, _tmp18_, _tmp19_);
	_clinica_sql_column_unref0 (col);
}


const gchar* clinica_sql_data_type_get_text (ClinicaSqlDataType* self, const gchar* field) {
	const gchar* result = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_ = NULL;
	ClinicaSqlColumn* col;
	ClinicaSqlColumn* _tmp14_;
	const gchar* _tmp15_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	_tmp0_ = self->columns;
	_tmp1_ = field;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	if (!_tmp2_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = field;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = self->table_name;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat ("Error loading from field ", _tmp4_, " from table ", _tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, "Selected field is not present in database", NULL);
		_tmp10_ = _tmp9_;
		g_signal_emit_by_name (self, "error", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		result = "";
		return result;
	}
	_tmp11_ = self->columns;
	_tmp12_ = field;
	_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
	col = (ClinicaSqlColumn*) _tmp13_;
	_tmp14_ = col;
	_tmp15_ = _tmp14_->v;
	result = _tmp15_;
	_clinica_sql_column_unref0 (col);
	return result;
}


gint clinica_sql_data_type_get_integer (ClinicaSqlDataType* self, const gchar* field) {
	gint result = 0;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_ = NULL;
	ClinicaSqlColumn* col;
	ClinicaSqlColumn* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (field != NULL, 0);
	_tmp0_ = self->columns;
	_tmp1_ = field;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	if (!_tmp2_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = field;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = self->table_name;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat ("Error loading from field ", _tmp4_, " from table ", _tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, "Selected field is not present in database", NULL);
		_tmp10_ = _tmp9_;
		g_signal_emit_by_name (self, "error", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		result = 0;
		return result;
	}
	_tmp11_ = self->columns;
	_tmp12_ = field;
	_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
	col = (ClinicaSqlColumn*) _tmp13_;
	_tmp14_ = col;
	_tmp15_ = _tmp14_->v;
	_tmp16_ = atoi (_tmp15_);
	result = _tmp16_;
	_clinica_sql_column_unref0 (col);
	return result;
}


GDateTime* clinica_sql_data_type_get_date (ClinicaSqlDataType* self, const gchar* field) {
	GDateTime* result = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp12_;
	const gchar* _tmp13_;
	gpointer _tmp14_ = NULL;
	ClinicaSqlColumn* col;
	ClinicaSqlColumn* _tmp15_;
	const gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_ = NULL;
	gchar** fields;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	const gchar* _tmp20_;
	gint _tmp21_ = 0;
	gint year;
	gchar** _tmp22_;
	gint _tmp22__length1;
	const gchar* _tmp23_;
	gint _tmp24_ = 0;
	gint month;
	gchar** _tmp25_;
	gint _tmp25__length1;
	const gchar* _tmp26_;
	gint _tmp27_ = 0;
	gint day;
	gchar** _tmp28_;
	gint _tmp28__length1;
	const gchar* _tmp29_;
	gint _tmp30_ = 0;
	gint hour;
	gchar** _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	gint _tmp33_ = 0;
	gint minute;
	gchar** _tmp34_;
	gint _tmp34__length1;
	const gchar* _tmp35_;
	gint _tmp36_ = 0;
	gint seconds;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gint _tmp46_;
	gboolean _tmp48_;
	gboolean _tmp50_;
	gboolean _tmp52_;
	gboolean _tmp54_;
	gboolean _tmp56_;
	gboolean _tmp58_;
	gboolean _tmp60_;
	gboolean _tmp62_;
	gboolean _tmp64_;
	gint _tmp66_;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	gint _tmp71_;
	GDateTime* _tmp72_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	_tmp0_ = self->columns;
	_tmp1_ = field;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	if (!_tmp2_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GDateTime* _tmp11_;
		_tmp3_ = field;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = self->table_name;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat ("Error loading from field ", _tmp4_, " from table ", _tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, "Selected field is not present in database", NULL);
		_tmp10_ = _tmp9_;
		g_signal_emit_by_name (self, "error", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		_tmp11_ = g_date_time_new_now_utc ();
		result = _tmp11_;
		return result;
	}
	_tmp12_ = self->columns;
	_tmp13_ = field;
	_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, _tmp13_);
	col = (ClinicaSqlColumn*) _tmp14_;
	_tmp15_ = col;
	_tmp16_ = _tmp15_->v;
	_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, " ", 0);
	fields = _tmp18_;
	fields_length1 = _vala_array_length (_tmp17_);
	_fields_size_ = fields_length1;
	_tmp19_ = fields;
	_tmp19__length1 = fields_length1;
	_tmp20_ = _tmp19_[0];
	_tmp21_ = atoi (_tmp20_);
	year = _tmp21_;
	_tmp22_ = fields;
	_tmp22__length1 = fields_length1;
	_tmp23_ = _tmp22_[1];
	_tmp24_ = atoi (_tmp23_);
	month = _tmp24_;
	_tmp25_ = fields;
	_tmp25__length1 = fields_length1;
	_tmp26_ = _tmp25_[2];
	_tmp27_ = atoi (_tmp26_);
	day = _tmp27_;
	_tmp28_ = fields;
	_tmp28__length1 = fields_length1;
	_tmp29_ = _tmp28_[3];
	_tmp30_ = atoi (_tmp29_);
	hour = _tmp30_;
	_tmp31_ = fields;
	_tmp31__length1 = fields_length1;
	_tmp32_ = _tmp31_[4];
	_tmp33_ = atoi (_tmp32_);
	minute = _tmp33_;
	_tmp34_ = fields;
	_tmp34__length1 = fields_length1;
	_tmp35_ = _tmp34_[5];
	_tmp36_ = atoi (_tmp35_);
	seconds = _tmp36_;
	_tmp46_ = year;
	if (_tmp46_ < 1) {
		_tmp45_ = TRUE;
	} else {
		gint _tmp47_;
		_tmp47_ = year;
		_tmp45_ = _tmp47_ > 9999;
	}
	_tmp48_ = _tmp45_;
	if (_tmp48_) {
		_tmp44_ = TRUE;
	} else {
		gint _tmp49_;
		_tmp49_ = month;
		_tmp44_ = _tmp49_ < 1;
	}
	_tmp50_ = _tmp44_;
	if (_tmp50_) {
		_tmp43_ = TRUE;
	} else {
		gint _tmp51_;
		_tmp51_ = month;
		_tmp43_ = _tmp51_ > 12;
	}
	_tmp52_ = _tmp43_;
	if (_tmp52_) {
		_tmp42_ = TRUE;
	} else {
		gint _tmp53_;
		_tmp53_ = day;
		_tmp42_ = _tmp53_ < 1;
	}
	_tmp54_ = _tmp42_;
	if (_tmp54_) {
		_tmp41_ = TRUE;
	} else {
		gint _tmp55_;
		_tmp55_ = day;
		_tmp41_ = _tmp55_ > 31;
	}
	_tmp56_ = _tmp41_;
	if (_tmp56_) {
		_tmp40_ = TRUE;
	} else {
		gint _tmp57_;
		_tmp57_ = minute;
		_tmp40_ = _tmp57_ < 0;
	}
	_tmp58_ = _tmp40_;
	if (_tmp58_) {
		_tmp39_ = TRUE;
	} else {
		gint _tmp59_;
		_tmp59_ = minute;
		_tmp39_ = _tmp59_ > 59;
	}
	_tmp60_ = _tmp39_;
	if (_tmp60_) {
		_tmp38_ = TRUE;
	} else {
		gint _tmp61_;
		_tmp61_ = seconds;
		_tmp38_ = _tmp61_ < 0;
	}
	_tmp62_ = _tmp38_;
	if (_tmp62_) {
		_tmp37_ = TRUE;
	} else {
		gint _tmp63_;
		_tmp63_ = seconds;
		_tmp37_ = _tmp63_ > 59;
	}
	_tmp64_ = _tmp37_;
	if (_tmp64_) {
		GDateTime* _tmp65_;
		_tmp65_ = g_date_time_new_now_local ();
		result = _tmp65_;
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
		_clinica_sql_column_unref0 (col);
		return result;
	}
	_tmp66_ = year;
	_tmp67_ = month;
	_tmp68_ = day;
	_tmp69_ = hour;
	_tmp70_ = minute;
	_tmp71_ = seconds;
	_tmp72_ = g_date_time_new_local (_tmp66_, _tmp67_, _tmp68_, _tmp69_, _tmp70_, (gdouble) _tmp71_);
	result = _tmp72_;
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
	_clinica_sql_column_unref0 (col);
	return result;
}


void clinica_sql_data_type_set_date (ClinicaSqlDataType* self, const gchar* field, GDateTime* date) {
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_ = NULL;
	ClinicaSqlColumn* col;
	ClinicaSqlColumn* _tmp14_;
	GDateTime* _tmp15_;
	gint _tmp16_ = 0;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_;
	GDateTime* _tmp19_;
	gint _tmp20_ = 0;
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_;
	GDateTime* _tmp23_;
	gint _tmp24_ = 0;
	gchar* _tmp25_ = NULL;
	gchar* _tmp26_;
	GDateTime* _tmp27_;
	gint _tmp28_ = 0;
	gchar* _tmp29_ = NULL;
	gchar* _tmp30_;
	GDateTime* _tmp31_;
	gint _tmp32_ = 0;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_;
	GDateTime* _tmp35_;
	gint _tmp36_ = 0;
	gchar* _tmp37_ = NULL;
	gchar* _tmp38_;
	gchar* _tmp39_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (date != NULL);
	_tmp0_ = self->columns;
	_tmp1_ = field;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	if (!_tmp2_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = field;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = self->table_name;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat ("Error saving tofield ", _tmp4_, " from table ", _tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, "Selected field is not present in database", NULL);
		_tmp10_ = _tmp9_;
		g_signal_emit_by_name (self, "error", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		return;
	}
	_tmp11_ = self->columns;
	_tmp12_ = field;
	_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
	col = (ClinicaSqlColumn*) _tmp13_;
	_tmp14_ = col;
	_tmp15_ = date;
	_tmp16_ = g_date_time_get_year (_tmp15_);
	_tmp17_ = g_strdup_printf ("%i", _tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = date;
	_tmp20_ = g_date_time_get_month (_tmp19_);
	_tmp21_ = g_strdup_printf ("%.2d", _tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = date;
	_tmp24_ = g_date_time_get_day_of_month (_tmp23_);
	_tmp25_ = g_strdup_printf ("%.2d", _tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = date;
	_tmp28_ = g_date_time_get_hour (_tmp27_);
	_tmp29_ = g_strdup_printf ("%.2d", _tmp28_);
	_tmp30_ = _tmp29_;
	_tmp31_ = date;
	_tmp32_ = g_date_time_get_minute (_tmp31_);
	_tmp33_ = g_strdup_printf ("%.2d", _tmp32_);
	_tmp34_ = _tmp33_;
	_tmp35_ = date;
	_tmp36_ = g_date_time_get_second (_tmp35_);
	_tmp37_ = g_strdup_printf ("%.2d", _tmp36_);
	_tmp38_ = _tmp37_;
	_tmp39_ = g_strjoin (" ", _tmp18_, _tmp22_, _tmp26_, _tmp30_, _tmp34_, _tmp38_, NULL);
	_g_free0 (_tmp14_->v);
	_tmp14_->v = _tmp39_;
	_g_free0 (_tmp38_);
	_g_free0 (_tmp34_);
	_g_free0 (_tmp30_);
	_g_free0 (_tmp26_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp18_);
	_clinica_sql_column_unref0 (col);
}


gint clinica_sql_data_type_get_id (ClinicaSqlDataType* self) {
	gint result = 0;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = clinica_sql_data_type_get_integer (self, "ID");
	result = _tmp0_;
	return result;
}


void clinica_sql_data_type_set_integer (ClinicaSqlDataType* self, const gchar* field, gint64 val) {
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	gpointer _tmp13_ = NULL;
	ClinicaSqlColumn* col;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_;
	gboolean _tmp17_;
	GeeHashMap* _tmp23_;
	const gchar* _tmp24_;
	ClinicaSqlColumn* _tmp25_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	_tmp0_ = self->columns;
	_tmp1_ = field;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
	if (!_tmp2_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = field;
		_tmp4_ = string_to_string (_tmp3_);
		_tmp5_ = self->table_name;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat ("Error saving tofield ", _tmp4_, " from table ", _tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, "Selected field is not present in database", NULL);
		_tmp10_ = _tmp9_;
		g_signal_emit_by_name (self, "error", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		return;
	}
	_tmp11_ = self->columns;
	_tmp12_ = field;
	_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
	col = (ClinicaSqlColumn*) _tmp13_;
	_tmp15_ = field;
	if (g_strcmp0 (_tmp15_, "ID") == 0) {
		gint64 _tmp16_;
		_tmp16_ = val;
		_tmp14_ = _tmp16_ == ((gint64) 0);
	} else {
		_tmp14_ = FALSE;
	}
	_tmp17_ = _tmp14_;
	if (_tmp17_) {
		ClinicaSqlColumn* _tmp18_;
		gchar* _tmp19_;
		_tmp18_ = col;
		_tmp19_ = g_strdup ("NULL");
		_g_free0 (_tmp18_->v);
		_tmp18_->v = _tmp19_;
	} else {
		ClinicaSqlColumn* _tmp20_;
		gint64 _tmp21_;
		gchar* _tmp22_ = NULL;
		_tmp20_ = col;
		_tmp21_ = val;
		_tmp22_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp21_);
		_g_free0 (_tmp20_->v);
		_tmp20_->v = _tmp22_;
	}
	_tmp23_ = self->columns;
	_tmp24_ = field;
	_tmp25_ = col;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, _tmp24_, _tmp25_);
	_clinica_sql_column_unref0 (col);
}


gchar* clinica_sql_data_type_get (ClinicaSqlDataType* self, const gchar* field) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	_tmp0_ = field;
	_tmp1_ = clinica_sql_data_type_get_text (self, _tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}


void clinica_sql_data_type_set (ClinicaSqlDataType* self, const gchar* field, const gchar* value) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (field != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = field;
	_tmp1_ = value;
	clinica_sql_data_type_set_text (self, _tmp0_, _tmp1_);
}


/**
         * @brief Save changes permanently in the database
         */
void clinica_sql_data_type_save (ClinicaSqlDataType* self) {
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* sql;
	const gchar* _tmp21_;
	gchar* _tmp22_ = NULL;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp59_;
	gchar* _tmp60_ = NULL;
	const gchar* _tmp61_;
	gchar* _tmp62_;
	sqlite3* _tmp63_;
	const gchar* _tmp64_;
	sqlite3_stmt* _tmp65_ = NULL;
	sqlite3_stmt* _tmp66_;
	gint _tmp67_ = 0;
	gint _tmp72_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table_name;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = g_strconcat ("INSERT OR REPLACE INTO ", _tmp1_, " (", NULL);
	sql = _tmp2_;
	{
		GeeHashMap* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _tmp8_;
		GeeIterator* _e_it;
		_tmp3_ = self->columns;
		_tmp4_ = gee_map_get_entries ((GeeMap*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_e_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeIterator* _tmp11_;
			gpointer _tmp12_ = NULL;
			GeeMapEntry* e;
			const gchar* _tmp13_;
			GeeMapEntry* _tmp14_;
			gconstpointer _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			gchar* _tmp20_;
			_tmp9_ = _e_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _e_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			e = (GeeMapEntry*) _tmp12_;
			_tmp13_ = sql;
			_tmp14_ = e;
			_tmp15_ = gee_map_entry_get_key (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = string_to_string ((const gchar*) _tmp16_);
			_tmp18_ = g_strconcat (_tmp17_, ", ", NULL);
			_tmp19_ = _tmp18_;
			_tmp20_ = g_strconcat (_tmp13_, _tmp19_, NULL);
			_g_free0 (sql);
			sql = _tmp20_;
			_g_free0 (_tmp19_);
			_g_object_unref0 (e);
		}
		_g_object_unref0 (_e_it);
	}
	_tmp21_ = sql;
	_tmp22_ = string_slice (_tmp21_, (glong) 0, (glong) (-2));
	_g_free0 (sql);
	sql = _tmp22_;
	_tmp23_ = sql;
	_tmp24_ = g_strconcat (_tmp23_, ") VALUES (", NULL);
	_g_free0 (sql);
	sql = _tmp24_;
	{
		GeeHashMap* _tmp25_;
		GeeSet* _tmp26_;
		GeeSet* _tmp27_;
		GeeSet* _tmp28_;
		GeeIterator* _tmp29_ = NULL;
		GeeIterator* _tmp30_;
		GeeIterator* _e_it;
		_tmp25_ = self->columns;
		_tmp26_ = gee_map_get_entries ((GeeMap*) _tmp25_);
		_tmp27_ = _tmp26_;
		_tmp28_ = _tmp27_;
		_tmp29_ = gee_iterable_iterator ((GeeIterable*) _tmp28_);
		_tmp30_ = _tmp29_;
		_g_object_unref0 (_tmp28_);
		_e_it = _tmp30_;
		while (TRUE) {
			GeeIterator* _tmp31_;
			gboolean _tmp32_ = FALSE;
			GeeIterator* _tmp33_;
			gpointer _tmp34_ = NULL;
			GeeMapEntry* e;
			GeeMapEntry* _tmp35_;
			gconstpointer _tmp36_;
			ClinicaSqlColumn* _tmp37_;
			const gchar* _tmp38_;
			_tmp31_ = _e_it;
			_tmp32_ = gee_iterator_next (_tmp31_);
			if (!_tmp32_) {
				break;
			}
			_tmp33_ = _e_it;
			_tmp34_ = gee_iterator_get (_tmp33_);
			e = (GeeMapEntry*) _tmp34_;
			_tmp35_ = e;
			_tmp36_ = gee_map_entry_get_value (_tmp35_);
			_tmp37_ = _tmp36_;
			_tmp38_ = ((ClinicaSqlColumn*) _tmp37_)->type;
			if (g_strcmp0 (_tmp38_, "TEXT") == 0) {
				const gchar* _tmp39_;
				GeeMapEntry* _tmp40_;
				gconstpointer _tmp41_;
				ClinicaSqlColumn* _tmp42_;
				const gchar* _tmp43_;
				gchar* _tmp44_ = NULL;
				gchar* _tmp45_;
				const gchar* _tmp46_ = NULL;
				gchar* _tmp47_ = NULL;
				gchar* _tmp48_;
				gchar* _tmp49_;
				_tmp39_ = sql;
				_tmp40_ = e;
				_tmp41_ = gee_map_entry_get_value (_tmp40_);
				_tmp42_ = _tmp41_;
				_tmp43_ = ((ClinicaSqlColumn*) _tmp42_)->v;
				_tmp44_ = clinica_sql_data_type_quote (self, _tmp43_);
				_tmp45_ = _tmp44_;
				_tmp46_ = string_to_string (_tmp45_);
				_tmp47_ = g_strconcat (_tmp46_, ", ", NULL);
				_tmp48_ = _tmp47_;
				_tmp49_ = g_strconcat (_tmp39_, _tmp48_, NULL);
				_g_free0 (sql);
				sql = _tmp49_;
				_g_free0 (_tmp48_);
				_g_free0 (_tmp45_);
			} else {
				const gchar* _tmp50_;
				GeeMapEntry* _tmp51_;
				gconstpointer _tmp52_;
				ClinicaSqlColumn* _tmp53_;
				const gchar* _tmp54_;
				const gchar* _tmp55_ = NULL;
				gchar* _tmp56_ = NULL;
				gchar* _tmp57_;
				gchar* _tmp58_;
				_tmp50_ = sql;
				_tmp51_ = e;
				_tmp52_ = gee_map_entry_get_value (_tmp51_);
				_tmp53_ = _tmp52_;
				_tmp54_ = ((ClinicaSqlColumn*) _tmp53_)->v;
				_tmp55_ = string_to_string (_tmp54_);
				_tmp56_ = g_strconcat (_tmp55_, ", ", NULL);
				_tmp57_ = _tmp56_;
				_tmp58_ = g_strconcat (_tmp50_, _tmp57_, NULL);
				_g_free0 (sql);
				sql = _tmp58_;
				_g_free0 (_tmp57_);
			}
			_g_object_unref0 (e);
		}
		_g_object_unref0 (_e_it);
	}
	_tmp59_ = sql;
	_tmp60_ = string_slice (_tmp59_, (glong) 0, (glong) (-2));
	_g_free0 (sql);
	sql = _tmp60_;
	_tmp61_ = sql;
	_tmp62_ = g_strconcat (_tmp61_, ");", NULL);
	_g_free0 (sql);
	sql = _tmp62_;
	_tmp63_ = self->db;
	_tmp64_ = sql;
	sqlite3_prepare (_tmp63_, _tmp64_, -1, &_tmp65_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp65_;
	_tmp66_ = stmt;
	_tmp67_ = sqlite3_step (_tmp66_);
	if (_tmp67_ != SQLITE_DONE) {
		const gchar* _tmp68_;
		const gchar* _tmp69_ = NULL;
		gchar* _tmp70_ = NULL;
		gchar* _tmp71_;
		_tmp68_ = self->table_name;
		_tmp69_ = string_to_string (_tmp68_);
		_tmp70_ = g_strconcat ("Error inserting values in the database ", _tmp69_, NULL);
		_tmp71_ = _tmp70_;
		g_signal_emit_by_name (self, "error", _tmp71_);
		_g_free0 (_tmp71_);
	}
	_tmp72_ = clinica_sql_data_type_get_id (self);
	if (_tmp72_ == 0) {
		sqlite3* _tmp73_;
		gint64 _tmp74_ = 0LL;
		_tmp73_ = self->db;
		_tmp74_ = sqlite3_last_insert_rowid (_tmp73_);
		clinica_sql_data_type_set_integer (self, "ID", _tmp74_);
	}
	_g_free0 (sql);
	_sqlite3_finalize0 (stmt);
}


/**
         * @brief Load data from database, overwriting local
         * variables.
         */
void clinica_sql_data_type_load (ClinicaSqlDataType* self, gint ID) {
	gint _tmp0_;
	sqlite3_stmt* stmt = NULL;
	gchar* _tmp2_;
	gchar* sql;
	const gchar* _tmp21_;
	gchar* _tmp22_ = NULL;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_ = NULL;
	gint _tmp26_;
	gchar* _tmp27_ = NULL;
	gchar* _tmp28_;
	gchar* _tmp29_ = NULL;
	gchar* _tmp30_;
	gchar* _tmp31_;
	sqlite3* _tmp32_;
	const gchar* _tmp33_;
	sqlite3_stmt* _tmp34_ = NULL;
	sqlite3_stmt* _tmp35_;
	gint _tmp36_ = 0;
	gint i;
	g_return_if_fail (self != NULL);
	_tmp0_ = ID;
	if (_tmp0_ == 0) {
		gint _tmp1_ = 0;
		_tmp1_ = clinica_sql_data_type_get_integer (self, "ID");
		ID = _tmp1_;
	}
	_tmp2_ = g_strdup ("SELECT ");
	sql = _tmp2_;
	{
		GeeHashMap* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _tmp8_;
		GeeIterator* _e_it;
		_tmp3_ = self->columns;
		_tmp4_ = gee_map_get_entries ((GeeMap*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_e_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeIterator* _tmp11_;
			gpointer _tmp12_ = NULL;
			GeeMapEntry* e;
			const gchar* _tmp13_;
			GeeMapEntry* _tmp14_;
			gconstpointer _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			gchar* _tmp20_;
			_tmp9_ = _e_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _e_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			e = (GeeMapEntry*) _tmp12_;
			_tmp13_ = sql;
			_tmp14_ = e;
			_tmp15_ = gee_map_entry_get_key (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = string_to_string ((const gchar*) _tmp16_);
			_tmp18_ = g_strconcat (_tmp17_, ", ", NULL);
			_tmp19_ = _tmp18_;
			_tmp20_ = g_strconcat (_tmp13_, _tmp19_, NULL);
			_g_free0 (sql);
			sql = _tmp20_;
			_g_free0 (_tmp19_);
			_g_object_unref0 (e);
		}
		_g_object_unref0 (_e_it);
	}
	_tmp21_ = sql;
	_tmp22_ = string_slice (_tmp21_, (glong) 0, (glong) (-2));
	_g_free0 (sql);
	sql = _tmp22_;
	_tmp23_ = sql;
	_tmp24_ = self->table_name;
	_tmp25_ = string_to_string (_tmp24_);
	_tmp26_ = ID;
	_tmp27_ = g_strdup_printf ("%i", _tmp26_);
	_tmp28_ = _tmp27_;
	_tmp29_ = g_strconcat (" FROM ", _tmp25_, " WHERE ID=", _tmp28_, ";", NULL);
	_tmp30_ = _tmp29_;
	_tmp31_ = g_strconcat (_tmp23_, _tmp30_, NULL);
	_g_free0 (sql);
	sql = _tmp31_;
	_g_free0 (_tmp30_);
	_g_free0 (_tmp28_);
	_tmp32_ = self->db;
	_tmp33_ = sql;
	sqlite3_prepare (_tmp32_, _tmp33_, -1, &_tmp34_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp34_;
	_tmp35_ = stmt;
	_tmp36_ = sqlite3_step (_tmp35_);
	if (_tmp36_ != SQLITE_ROW) {
		const gchar* _tmp37_;
		const gchar* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_;
		_tmp37_ = self->table_name;
		_tmp38_ = string_to_string (_tmp37_);
		_tmp39_ = g_strconcat ("Error loading data from table ", _tmp38_, ".", NULL);
		_tmp40_ = _tmp39_;
		g_signal_emit_by_name (self, "error", _tmp40_);
		_g_free0 (_tmp40_);
		_g_free0 (sql);
		_sqlite3_finalize0 (stmt);
		return;
	}
	i = 0;
	{
		GeeHashMap* _tmp41_;
		GeeSet* _tmp42_;
		GeeSet* _tmp43_;
		GeeSet* _tmp44_;
		GeeIterator* _tmp45_ = NULL;
		GeeIterator* _tmp46_;
		GeeIterator* _e_it;
		_tmp41_ = self->columns;
		_tmp42_ = gee_map_get_entries ((GeeMap*) _tmp41_);
		_tmp43_ = _tmp42_;
		_tmp44_ = _tmp43_;
		_tmp45_ = gee_iterable_iterator ((GeeIterable*) _tmp44_);
		_tmp46_ = _tmp45_;
		_g_object_unref0 (_tmp44_);
		_e_it = _tmp46_;
		while (TRUE) {
			GeeIterator* _tmp47_;
			gboolean _tmp48_ = FALSE;
			GeeIterator* _tmp49_;
			gpointer _tmp50_ = NULL;
			GeeMapEntry* e;
			GeeMapEntry* _tmp51_;
			gconstpointer _tmp52_;
			ClinicaSqlColumn* _tmp53_;
			const gchar* _tmp54_;
			gint _tmp69_;
			_tmp47_ = _e_it;
			_tmp48_ = gee_iterator_next (_tmp47_);
			if (!_tmp48_) {
				break;
			}
			_tmp49_ = _e_it;
			_tmp50_ = gee_iterator_get (_tmp49_);
			e = (GeeMapEntry*) _tmp50_;
			_tmp51_ = e;
			_tmp52_ = gee_map_entry_get_value (_tmp51_);
			_tmp53_ = _tmp52_;
			_tmp54_ = ((ClinicaSqlColumn*) _tmp53_)->type;
			if (g_strcmp0 (_tmp54_, "TEXT") == 0) {
				GeeMapEntry* _tmp55_;
				gconstpointer _tmp56_;
				ClinicaSqlColumn* _tmp57_;
				sqlite3_stmt* _tmp58_;
				gint _tmp59_;
				const gchar* _tmp60_ = NULL;
				gchar* _tmp61_ = NULL;
				_tmp55_ = e;
				_tmp56_ = gee_map_entry_get_value (_tmp55_);
				_tmp57_ = _tmp56_;
				_tmp58_ = stmt;
				_tmp59_ = i;
				_tmp60_ = sqlite3_column_text (_tmp58_, _tmp59_);
				_tmp61_ = g_strcompress (_tmp60_);
				_g_free0 (((ClinicaSqlColumn*) _tmp57_)->v);
				((ClinicaSqlColumn*) _tmp57_)->v = _tmp61_;
			} else {
				GeeMapEntry* _tmp62_;
				gconstpointer _tmp63_;
				ClinicaSqlColumn* _tmp64_;
				sqlite3_stmt* _tmp65_;
				gint _tmp66_;
				const gchar* _tmp67_ = NULL;
				gchar* _tmp68_;
				_tmp62_ = e;
				_tmp63_ = gee_map_entry_get_value (_tmp62_);
				_tmp64_ = _tmp63_;
				_tmp65_ = stmt;
				_tmp66_ = i;
				_tmp67_ = sqlite3_column_text (_tmp65_, _tmp66_);
				_tmp68_ = g_strdup (_tmp67_);
				_g_free0 (((ClinicaSqlColumn*) _tmp64_)->v);
				((ClinicaSqlColumn*) _tmp64_)->v = _tmp68_;
			}
			_tmp69_ = i;
			i = _tmp69_ + 1;
			_g_object_unref0 (e);
		}
		_g_object_unref0 (_e_it);
	}
	_g_free0 (sql);
	_sqlite3_finalize0 (stmt);
}


/**
         * @brief Delete this item permanently from the database.
         */
void clinica_sql_data_type_remove (ClinicaSqlDataType* self) {
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* sql;
	sqlite3* _tmp7_;
	const gchar* _tmp8_;
	sqlite3_stmt* _tmp9_ = NULL;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table_name;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = clinica_sql_data_type_get_id (self);
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("DELETE from ", _tmp1_, " WHERE ID=", _tmp4_, ";", NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	sql = _tmp6_;
	_tmp7_ = self->db;
	_tmp8_ = sql;
	sqlite3_prepare (_tmp7_, _tmp8_, -1, &_tmp9_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp9_;
	_tmp10_ = stmt;
	_tmp11_ = sqlite3_step (_tmp10_);
	if (_tmp11_ != SQLITE_DONE) {
		const gchar* _tmp12_;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
		_tmp12_ = self->table_name;
		_tmp13_ = string_to_string (_tmp12_);
		_tmp14_ = g_strconcat ("Error deleting item from the database ", _tmp13_, NULL);
		_tmp15_ = _tmp14_;
		g_signal_emit_by_name (self, "error", _tmp15_);
		_g_free0 (_tmp15_);
	}
	_g_free0 (sql);
	_sqlite3_finalize0 (stmt);
}


/**
         * @brief Find IDs of elements in ex_table (that is assumed to be a table
         * associateed to another SqlDataType object and return a vector
         * containing their IDs. 
         */
GList* clinica_sql_data_type_associated_ids (ClinicaSqlDataType* self, const gchar* ex_table, const gchar* foreign_key) {
	GList* result = NULL;
	GList* ids;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* sql;
	sqlite3* _tmp9_;
	const gchar* _tmp10_;
	sqlite3_stmt* _tmp11_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (ex_table != NULL, NULL);
	g_return_val_if_fail (foreign_key != NULL, NULL);
	ids = NULL;
	_tmp0_ = ex_table;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = foreign_key;
	_tmp3_ = string_to_string (_tmp2_);
	_tmp4_ = clinica_sql_data_type_get_id (self);
	_tmp5_ = g_strdup_printf ("%i", _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat ("SELECT ID from ", _tmp1_, " WHERE ", _tmp3_, "=", _tmp6_, ";", NULL);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	sql = _tmp8_;
	_tmp9_ = self->db;
	_tmp10_ = sql;
	sqlite3_prepare (_tmp9_, _tmp10_, -1, &_tmp11_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp11_;
	while (TRUE) {
		sqlite3_stmt* _tmp12_;
		gint _tmp13_ = 0;
		sqlite3_stmt* _tmp14_;
		gint _tmp15_ = 0;
		_tmp12_ = stmt;
		_tmp13_ = sqlite3_step (_tmp12_);
		if (!(_tmp13_ == SQLITE_ROW)) {
			break;
		}
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_column_int (_tmp14_, 0);
		ids = g_list_append (ids, GINT_TO_POINTER (_tmp15_));
	}
	result = ids;
	_g_free0 (sql);
	_sqlite3_finalize0 (stmt);
	return result;
}


static void clinica_sql_data_type_class_init (ClinicaSqlDataTypeClass * klass) {
	clinica_sql_data_type_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ClinicaSqlDataTypePrivate));
	G_OBJECT_CLASS (klass)->finalize = clinica_sql_data_type_finalize;
	/**
	         * @brief Signal emitted when an error eris
	         * encountered
	         */
	g_signal_new ("error", CLINICA_TYPE_SQL_DATA_TYPE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void clinica_sql_data_type_instance_init (ClinicaSqlDataType * self) {
	self->priv = CLINICA_SQL_DATA_TYPE_GET_PRIVATE (self);
	g_static_rec_mutex_init (&self->priv->__lock_db);
}


static void clinica_sql_data_type_finalize (GObject* obj) {
	ClinicaSqlDataType * self;
	self = CLINICA_SQL_DATA_TYPE (obj);
	_g_free0 (self->table_name);
	g_static_rec_mutex_free (&self->priv->__lock_db);
	_g_object_unref0 (self->columns);
	G_OBJECT_CLASS (clinica_sql_data_type_parent_class)->finalize (obj);
}


/**
     * @brief Interface representing an abstract data
     * type interfaced to a SQLite database. 
     */
GType clinica_sql_data_type_get_type (void) {
	static volatile gsize clinica_sql_data_type_type_id__volatile = 0;
	if (g_once_init_enter (&clinica_sql_data_type_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClinicaSqlDataTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clinica_sql_data_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClinicaSqlDataType), 0, (GInstanceInitFunc) clinica_sql_data_type_instance_init, NULL };
		GType clinica_sql_data_type_type_id;
		clinica_sql_data_type_type_id = g_type_register_static (G_TYPE_OBJECT, "ClinicaSqlDataType", &g_define_type_info, 0);
		g_once_init_leave (&clinica_sql_data_type_type_id__volatile, clinica_sql_data_type_type_id);
	}
	return clinica_sql_data_type_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



