/* Utils.c generated by valac 0.13.4, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 *   This file is part of Clinica.
 *
 *   Clinica is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   Clinica is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Clinica.  If not, see <http://www.gnu.org/licenses/>.
 *
 *   Authors: Leonardo Robol <leo@robol.it>
 *            Gianmarco Brocchi <brocchi@poisson.phc.unipi.it>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CLINICA_TYPE_USER_INTERFACE (clinica_user_interface_get_type ())
#define CLINICA_USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLINICA_TYPE_USER_INTERFACE, ClinicaUserInterface))
#define CLINICA_USER_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLINICA_TYPE_USER_INTERFACE, ClinicaUserInterfaceClass))
#define CLINICA_IS_USER_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLINICA_TYPE_USER_INTERFACE))
#define CLINICA_IS_USER_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLINICA_TYPE_USER_INTERFACE))
#define CLINICA_USER_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLINICA_TYPE_USER_INTERFACE, ClinicaUserInterfaceClass))

typedef struct _ClinicaUserInterface ClinicaUserInterface;
typedef struct _ClinicaUserInterfaceClass ClinicaUserInterfaceClass;


extern ClinicaUserInterface* clinica_application_user_interface;

gchar* clinica_utils_capitalize (const gchar* input);
static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add3 (gchar*** array, int* length, int* size, gchar* value);
void clinica_utils_set_widget_size (GtkWidget* widget, gint width, gint height);
void clinica_utils_show_error_message (GObject* source, const gchar* message);
GType clinica_user_interface_get_type (void) G_GNUC_CONST;
gboolean clinica_user_interface_get_started (ClinicaUserInterface* self);
gboolean clinica_utils_check_date (gint day, gint month, gint year);
static gboolean _vala_int_array_contains (gint* stack, int stack_length, gint needle);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * @brief Returned the capitalized version of input
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	glong string_length;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	glong _tmp14_;
	gboolean _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_;
		glong _tmp4_;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_;
		glong _tmp7_;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp12_ = _tmp8_;
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp14_ = end;
	if (_tmp14_ >= ((glong) 0)) {
		glong _tmp15_;
		glong _tmp16_;
		_tmp15_ = end;
		_tmp16_ = string_length;
		_tmp13_ = _tmp15_ <= _tmp16_;
	} else {
		_tmp13_ = FALSE;
	}
	_tmp17_ = _tmp13_;
	g_return_val_if_fail (_tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	g_return_val_if_fail (_tmp18_ <= _tmp19_, NULL);
	_tmp20_ = start;
	_tmp21_ = end;
	_tmp22_ = start;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) (_tmp21_ - _tmp22_));
	result = _tmp23_;
	return result;
}


static void _vala_array_add2 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add3 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


gchar* clinica_utils_capitalize (const gchar* input) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_ = NULL;
	gchar** pieces;
	gint pieces_length1;
	gint _pieces_size_;
	gchar** _tmp3_ = NULL;
	gchar** new_pieces;
	gint new_pieces_length1;
	gint _new_pieces_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar* _tmp28_ = NULL;
	g_return_val_if_fail (input != NULL, NULL);
	_tmp0_ = input;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, " ", 0);
	pieces = _tmp2_;
	pieces_length1 = _vala_array_length (_tmp1_);
	_pieces_size_ = pieces_length1;
	_tmp3_ = g_new0 (gchar*, 0 + 1);
	new_pieces = _tmp3_;
	new_pieces_length1 = 0;
	_new_pieces_size_ = new_pieces_length1;
	_tmp4_ = pieces;
	_tmp4__length1 = pieces_length1;
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
		str_collection = _tmp4_;
		str_collection_length1 = _tmp4__length1;
		for (str_it = 0; str_it < _tmp4__length1; str_it = str_it + 1) {
			gchar* _tmp5_;
			gchar* str = NULL;
			_tmp5_ = g_strdup (str_collection[str_it]);
			str = _tmp5_;
			{
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				_tmp6_ = str;
				_tmp7_ = strlen (_tmp6_);
				_tmp8_ = _tmp7_;
				if (_tmp8_ > 1) {
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
					gchar _tmp11_ = '\0';
					gchar _tmp12_ = '\0';
					gchar* _tmp13_ = NULL;
					gchar* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					gchar* _tmp19_ = NULL;
					gchar* _tmp20_;
					gchar* _tmp21_;
					_tmp9_ = new_pieces;
					_tmp9__length1 = new_pieces_length1;
					_tmp10_ = str;
					_tmp11_ = string_get (_tmp10_, (glong) 0);
					_tmp12_ = g_ascii_toupper (_tmp11_);
					_tmp13_ = g_strdup_printf ("%c", _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = str;
					_tmp16_ = str;
					_tmp17_ = strlen (_tmp16_);
					_tmp18_ = _tmp17_;
					_tmp19_ = string_slice (_tmp15_, (glong) 1, (glong) _tmp18_);
					_tmp20_ = _tmp19_;
					_tmp21_ = g_strconcat (_tmp14_, _tmp20_, NULL);
					_vala_array_add2 (&new_pieces, &new_pieces_length1, &_new_pieces_size_, _tmp21_);
					_g_free0 (_tmp20_);
					_g_free0 (_tmp14_);
				} else {
					gchar** _tmp22_;
					gint _tmp22__length1;
					const gchar* _tmp23_;
					gchar _tmp24_ = '\0';
					gchar _tmp25_ = '\0';
					gchar* _tmp26_ = NULL;
					_tmp22_ = new_pieces;
					_tmp22__length1 = new_pieces_length1;
					_tmp23_ = str;
					_tmp24_ = string_get (_tmp23_, (glong) 0);
					_tmp25_ = g_ascii_toupper (_tmp24_);
					_tmp26_ = g_strdup_printf ("%c", _tmp25_);
					_vala_array_add3 (&new_pieces, &new_pieces_length1, &_new_pieces_size_, _tmp26_);
				}
				_g_free0 (str);
			}
		}
	}
	_tmp27_ = new_pieces;
	_tmp27__length1 = new_pieces_length1;
	_tmp28_ = g_strjoinv (" ", _tmp27_);
	result = _tmp28_;
	new_pieces = (_vala_array_free (new_pieces, new_pieces_length1, (GDestroyNotify) g_free), NULL);
	pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void clinica_utils_set_widget_size (GtkWidget* widget, gint width, gint height) {
	GdkScreen* _tmp0_ = NULL;
	GdkScreen* _tmp1_;
	GdkScreen* screen;
	gint _tmp2_;
	GdkScreen* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp7_;
	GdkScreen* _tmp8_;
	gint _tmp9_ = 0;
	GtkWidget* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	g_return_if_fail (widget != NULL);
	_tmp0_ = gdk_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = width;
	_tmp3_ = screen;
	_tmp4_ = gdk_screen_get_width (_tmp3_);
	if (_tmp2_ > _tmp4_) {
		GdkScreen* _tmp5_;
		gint _tmp6_ = 0;
		_tmp5_ = screen;
		_tmp6_ = gdk_screen_get_width (_tmp5_);
		width = _tmp6_ - 100;
	}
	_tmp7_ = height;
	_tmp8_ = screen;
	_tmp9_ = gdk_screen_get_height (_tmp8_);
	if (_tmp7_ > _tmp9_) {
		GdkScreen* _tmp10_;
		gint _tmp11_ = 0;
		_tmp10_ = screen;
		_tmp11_ = gdk_screen_get_height (_tmp10_);
		height = _tmp11_ - 100;
	}
	_tmp12_ = widget;
	_tmp13_ = width;
	_tmp14_ = height;
	gtk_widget_set_size_request (_tmp12_, _tmp13_, _tmp14_);
	_g_object_unref0 (screen);
}


/**
     * @brief Show error message to the user
     */
void clinica_utils_show_error_message (GObject* source, const gchar* message) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	ClinicaUserInterface* _tmp7_;
	gboolean _tmp11_;
	const gchar* _tmp12_ = NULL;
	GtkMessageDialog* _tmp13_;
	GtkMessageDialog* _tmp14_;
	GtkMessageDialog* md;
	GtkMessageDialog* _tmp15_;
	const gchar* _tmp16_ = NULL;
	GtkMessageDialog* _tmp17_;
	const gchar* _tmp18_;
	GtkMessageDialog* _tmp19_;
	GtkMessageDialog* _tmp20_;
	g_return_if_fail (message != NULL);
	_tmp0_ = _ ("\033[31;1mERROR\033[0m => ");
	_tmp1_ = message;
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "\n", NULL);
	_tmp5_ = _tmp4_;
	g_print ("%s", _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_tmp7_ = clinica_application_user_interface;
	if (_tmp7_ == NULL) {
		_tmp6_ = TRUE;
	} else {
		ClinicaUserInterface* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp8_ = clinica_application_user_interface;
		_tmp9_ = clinica_user_interface_get_started (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp6_ = !_tmp10_;
	}
	_tmp11_ = _tmp6_;
	if (_tmp11_) {
		return;
	}
	_tmp12_ = _ ("Clinica encountered an error");
	_tmp13_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", _tmp12_);
	_tmp14_ = g_object_ref_sink (_tmp13_);
	md = _tmp14_;
	_tmp15_ = md;
	_tmp16_ = _ ("Clinica encountered an error");
	gtk_window_set_title ((GtkWindow*) _tmp15_, _tmp16_);
	_tmp17_ = md;
	_tmp18_ = message;
	gtk_message_dialog_format_secondary_markup (_tmp17_, "%s", _tmp18_);
	_tmp19_ = md;
	gtk_dialog_run ((GtkDialog*) _tmp19_);
	_tmp20_ = md;
	gtk_object_destroy ((GtkObject*) _tmp20_);
	_g_object_unref0 (md);
}


/**
     * @brief Check patient's birthday
     */
static gboolean _vala_int_array_contains (gint* stack, int stack_length, gint needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}


gboolean clinica_utils_check_date (gint day, gint month, gint year) {
	gboolean result = FALSE;
	gint* _tmp0_ = NULL;
	gint* thirtyone;
	gint thirtyone_length1;
	gint _thirtyone_size_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gboolean _tmp7_;
	gboolean _tmp12_;
	gboolean _tmp14_;
	_tmp0_ = g_new0 (gint, 7);
	_tmp0_[0] = 1;
	_tmp0_[1] = 3;
	_tmp0_[2] = 5;
	_tmp0_[3] = 7;
	_tmp0_[4] = 8;
	_tmp0_[5] = 10;
	_tmp0_[6] = 12;
	thirtyone = _tmp0_;
	thirtyone_length1 = 7;
	_thirtyone_size_ = thirtyone_length1;
	_tmp4_ = day;
	if (_tmp4_ == 31) {
		gint _tmp5_;
		gint* _tmp6_;
		gint _tmp6__length1;
		_tmp5_ = month;
		_tmp6_ = thirtyone;
		_tmp6__length1 = thirtyone_length1;
		_tmp3_ = _vala_int_array_contains (_tmp6_, _tmp6__length1, _tmp5_);
	} else {
		_tmp3_ = FALSE;
	}
	_tmp7_ = _tmp3_;
	if (_tmp7_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp8_ = FALSE;
		gint _tmp9_;
		gboolean _tmp11_;
		_tmp9_ = day;
		if (_tmp9_ <= 30) {
			gint _tmp10_;
			_tmp10_ = month;
			_tmp8_ = _tmp10_ != 2;
		} else {
			_tmp8_ = FALSE;
		}
		_tmp11_ = _tmp8_;
		_tmp2_ = _tmp11_;
	}
	_tmp12_ = _tmp2_;
	if (_tmp12_) {
		_tmp1_ = TRUE;
	} else {
		gint _tmp13_;
		_tmp13_ = day;
		_tmp1_ = _tmp13_ <= 28;
	}
	_tmp14_ = _tmp1_;
	if (_tmp14_) {
		result = TRUE;
		thirtyone = (g_free (thirtyone), NULL);
		return result;
	} else {
		gboolean _tmp15_ = FALSE;
		gint _tmp16_;
		gboolean _tmp18_;
		_tmp16_ = day;
		if (_tmp16_ == 29) {
			gint _tmp17_;
			_tmp17_ = month;
			_tmp15_ = _tmp17_ == 2;
		} else {
			_tmp15_ = FALSE;
		}
		_tmp18_ = _tmp15_;
		if (_tmp18_) {
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gint _tmp21_;
			gboolean _tmp23_;
			gboolean _tmp25_;
			_tmp21_ = year;
			if ((_tmp21_ % 100) != 0) {
				gint _tmp22_;
				_tmp22_ = year;
				_tmp20_ = (_tmp22_ % 4) == 0;
			} else {
				_tmp20_ = FALSE;
			}
			_tmp23_ = _tmp20_;
			if (_tmp23_) {
				_tmp19_ = TRUE;
			} else {
				gint _tmp24_;
				_tmp24_ = year;
				_tmp19_ = (_tmp24_ % 400) == 0;
			}
			_tmp25_ = _tmp19_;
			if (_tmp25_) {
				result = TRUE;
				thirtyone = (g_free (thirtyone), NULL);
				return result;
			}
		}
		result = FALSE;
		thirtyone = (g_free (thirtyone), NULL);
		return result;
	}
	thirtyone = (g_free (thirtyone), NULL);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



